/// Copyright (c) 2021 Razeware LLC
/// 
/// Permission is hereby granted, free of charge, to any person obtaining a copy
/// of this software and associated documentation files (the "Software"), to deal
/// in the Software without restriction, including without limitation the rights
/// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
/// copies of the Software, and to permit persons to whom the Software is
/// furnished to do so, subject to the following conditions:
/// 
/// The above copyright notice and this permission notice shall be included in
/// all copies or substantial portions of the Software.
/// 
/// Notwithstanding the foregoing, you may not use, copy, modify, merge, publish,
/// distribute, sublicense, create a derivative work, and/or sell copies of the
/// Software in any work that is designed, intended, or marketed for pedagogical or
/// instructional purposes related to programming, coding, application development,
/// or information technology.  Permission for such use, copying, modification,
/// merger, publication, distribution, sublicensing, creation of derivative works,
/// or sale is expressly withheld.
/// 
/// This project and source code may use libraries or frameworks that are
/// released under various Open-Source licenses. Use of those libraries and
/// frameworks are governed by their own individual licenses.
///
/// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
/// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
/// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
/// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
/// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
/// THE SOFTWARE.

#include <metal_stdlib>
using namespace metal;
#import "Common.h"

/*
struct VertexIn {
  float4 position [[attribute(0)]];
    
};

vertex float4 vertex_sphere(const VertexIn vertexIn [[stage_in]],
                          constant Uniforms &uniforms [[buffer(1)]])
{
  float4 position = uniforms.projectionMatrix * uniforms.viewMatrix
 * uniforms.modelMatrix * vertexIn.position;
  return position;
}

fragment float4 fragment_sphere() {
  return float4(0, 0, 1, 1);
}*/

struct VertexIn {
    packed_float3 position;
    
} ;
 struct VertexOut {
  float4 position [[position]];
  float pointSize [[point_size]];
};

vertex VertexOut vertex_sphere(uint vertexID [[vertex_id]],const device VertexIn* vertex_array [[buffer(0)]],constant Uniforms &uniforms [[buffer(1)]]) {
   // packed_float3 position;
  /*
    VertexOut out = {
    float4(vertexIn[vertexID], 1),
    5.0
  };
   */
    VertexOut out;
    VertexIn VertexIn = vertex_array[vertexID];
    out.position =  uniforms.projectionMatrix * uniforms.viewMatrix
    * uniforms.modelMatrix * float4(VertexIn.position,1);
    out.pointSize = 5.0;
  return out;
}

fragment float4 fragment_sphere() {
  return float4(0.3, 0.3, 0.3, 1);
}

